---
title: WebGLRenderingContext.useProgram()
slug: Web/API/WebGLRenderingContext/useProgram
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.useProgram()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> sets the specified {{domxref("WebGLProgram")}} as part of the current rendering state.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.useProgram(<var>program</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt>program</dt>
	<dd>A {{domxref("WebGLProgram")}} to use.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var program = gl.createProgram();

// Attach pre-existing shaders
gl.attachShader(program, vertexShader);
gl.attachShader(program, fragmentShader);

gl.linkProgram(program);
gl.useProgram(program);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('WebGL', "#5.14.9", "useProgram")}}</td>
			<td>{{Spec2('WebGL')}}</td>
			<td>Initial definition.</td>
		</tr>
		<tr>
			<td>{{SpecName('OpenGL ES 2.0', "glUseProgram.xml", "glUseProgram")}}</td>
			<td>{{Spec2('OpenGL ES 2.0')}}</td>
			<td>Man page of the OpenGL API.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.useProgram")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("WebGLRenderingContext.createProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.deleteProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.isProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.linkProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.validateProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getProgramParameter()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getProgramInfoLog()")}}</li>
</ul>
